#include "ep_lib.hpp"
#include <mpi.h>
#include "ep_declaration.hpp"
#include "ep_mpi.hpp"

namespace ep_lib
{

  int MPI_Comm_rank(MPI_Comm comm, int* rank)
  {
    if(comm->is_ep)
    {
      Debug("MPI_Comm_rank with EP");
      return *rank = comm->ep_comm_ptr->size_rank_info[0].first;      
    }

    return MPI_Comm_rank_mpi(comm, rank);
  }


  int MPI_Comm_rank_mpi(MPI_Comm comm, int* rank)
  {
    Debug("MPI_Comm_rank with MPI");
    return ::MPI_Comm_rank(to_mpi_comm(comm->mpi_comm), rank);
  }


}


