#include "ep_lib.hpp"

#include <mpi.h>

::MPI_Comm MPI_COMM_WORLD_STD = MPI_COMM_WORLD;
//#undef MPI_COMM_WORLD


::MPI_Comm MPI_COMM_NULL_STD = MPI_COMM_NULL;
//#undef MPI_COMM_NULL


::MPI_Request MPI_REQUEST_NULL_STD = MPI_REQUEST_NULL;
//#undef MPI_REQUEST_NULL

::MPI_Info MPI_INFO_NULL_STD = MPI_INFO_NULL;
//#undef MPI_INFO_NULL

::MPI_Datatype MPI_INT_STD = MPI_INT;
::MPI_Datatype MPI_FLOAT_STD = MPI_FLOAT;
::MPI_Datatype MPI_DOUBLE_STD = MPI_DOUBLE;
::MPI_Datatype MPI_LONG_STD = MPI_LONG;
::MPI_Datatype MPI_CHAR_STD = MPI_CHAR;
::MPI_Datatype MPI_UNSIGNED_LONG_STD = MPI_UNSIGNED_LONG;
::MPI_Datatype MPI_UNSIGNED_CHAR_STD = MPI_UNSIGNED_CHAR;
::MPI_Datatype MPI_UINT64_T_STD = MPI_UINT64_T;
::MPI_Datatype MPI_LONG_LONG_INT_STD = MPI_LONG_LONG_INT;
::MPI_Datatype MPI_LONG_LONG_STD = MPI_LONG_LONG;
/*
#undef MPI_INT
#undef MPI_FLOAT
#undef MPI_DOUBLE
#undef MPI_LONG
#undef MPI_CHAR
#undef MPI_UNSIGNED_LONG
#undef MPI_UNSIGNED_CHAR
#undef MPI_UINT64_T
#undef MPI_LONG_LONG_INT
*/

::MPI_Op MPI_SUM_STD = MPI_SUM;
::MPI_Op MPI_MAX_STD = MPI_MAX;
::MPI_Op MPI_MIN_STD = MPI_MIN;
::MPI_Op MPI_LOR_STD = MPI_LOR;
::MPI_Op MPI_REPLACE_STD = MPI_REPLACE;
/*
#undef MPI_SUM
#undef MPI_MAX
#undef MPI_MIN
#undef MPI_LOR
#undef MPI_REPLACE
*/

// _STD defined in ep_type.cpp

extern ::MPI_Datatype MPI_INT_STD;
extern ::MPI_Datatype MPI_FLOAT_STD;
extern ::MPI_Datatype MPI_DOUBLE_STD;
extern ::MPI_Datatype MPI_LONG_STD;
extern ::MPI_Datatype MPI_CHAR_STD;
extern ::MPI_Datatype MPI_UNSIGNED_LONG_STD;
extern ::MPI_Datatype MPI_UNSIGNED_CHAR_STD;
extern ::MPI_Datatype MPI_UINT64_T_STD;
extern ::MPI_Datatype MPI_LONG_LONG_INT_STD;
extern ::MPI_Datatype MPI_LONG_LONG_STD;



extern ::MPI_Op MPI_SUM_STD;
extern ::MPI_Op MPI_MAX_STD;
extern ::MPI_Op MPI_MIN_STD;
extern ::MPI_Op MPI_LOR_STD;
extern ::MPI_Op MPI_REPLACE_STD;

extern ::MPI_Comm MPI_COMM_WORLD_STD;
extern ::MPI_Comm MPI_COMM_NULL_STD;

extern ::MPI_Status MPI_STATUS_IGNORE_STD;
extern ::MPI_Request MPI_REQUEST_NULL_STD;
extern ::MPI_Info MPI_INFO_NULL_STD;

ep_lib::MPI_Datatype EP_INT = &MPI_INT_STD;
ep_lib::MPI_Datatype EP_FLOAT = &MPI_FLOAT_STD;
ep_lib::MPI_Datatype EP_DOUBLE = &MPI_DOUBLE_STD;
ep_lib::MPI_Datatype EP_CHAR = &MPI_CHAR_STD;
ep_lib::MPI_Datatype EP_LONG = &MPI_LONG_STD;
ep_lib::MPI_Datatype EP_UNSIGNED_LONG = &MPI_UNSIGNED_LONG_STD;
ep_lib::MPI_Datatype EP_UNSIGNED_CHAR = &MPI_UNSIGNED_CHAR_STD;
ep_lib::MPI_Datatype EP_UINT64_T = &MPI_UINT64_T_STD;
ep_lib::MPI_Datatype EP_LONG_LONG_INT = &MPI_LONG_LONG_INT_STD;
ep_lib::MPI_Datatype EP_LONG_LONG = &MPI_LONG_LONG_STD;



ep_lib::MPI_Op EP_SUM = &MPI_SUM_STD;
ep_lib::MPI_Op EP_MAX = &MPI_MAX_STD;
ep_lib::MPI_Op EP_MIN = &MPI_MIN_STD;
ep_lib::MPI_Op EP_LOR = &MPI_LOR_STD;
ep_lib::MPI_Op EP_REPLACE = &MPI_REPLACE_STD;

ep_lib::ep_comm EP_COMM_WORLD_t(&MPI_COMM_WORLD_STD);
ep_lib::ep_comm EP_COMM_NULL_t(&MPI_COMM_NULL_STD);

ep_lib::MPI_Comm EP_COMM_WORLD = &EP_COMM_WORLD_t;
ep_lib::MPI_Comm EP_COMM_NULL = &EP_COMM_NULL_t;

//ep_lib::ep_status EP_STATUS_IGNORE(&MPI_STATUS_IGNORE_STD);
ep_lib::ep_request EP_REQUEST_NULL_t(&MPI_REQUEST_NULL_STD);
ep_lib::ep_info EP_INFO_NULL_t(&MPI_INFO_NULL_STD);

//ep_lib::MPI_Status MPI_STATUS_IGNORE = &EP_STATUS_IGNORE;
ep_lib::MPI_Request EP_REQUEST_NULL = &EP_REQUEST_NULL_t;
ep_lib::MPI_Info EP_INFO_NULL = &EP_INFO_NULL_t;



